# FDS-SMV Discussion Group Policy Statement

The [FDS and Smokeview (FDS-SMV) Discussion Group](https://groups.google.com/forum/?fromgroups#!forum/fds-smv) and associated pages, such as [Issues](https://github.com/firemodels/fds/issues), have been created to enable open scientific and technical communication. While this group was established and is managed by the development team at NIST, we intend for this to be an open forum for multi-directional communication between all involved in the community, and not just between users and developers.  NIST participants will reply when it is appropriate for them to do so, and may limit their participation in some topics when it is not.  For example, NIST will not provide advice or comment on any matter that is or may be the subject of a legal proceeding. 

To further these objectives, the Discussion Group operates according to the following policies:

## Registration

The [FDS and Smokeview (FDS-SMV) Discussion Group](https://groups.google.com/forum/?fromgroups#!forum/fds-smv) does not permit anonymous public posting to the group.  Anyone with a free Google Account can request an invitation to join.  As part of the invitation request process, new members must respond to a simple statement, "Please state your purpose for using FDS or joining this group.  This will help Managers determine if an applicant is a spam robot or a new member." Managers read the responses to help determine if the request is from a user or from an automated system.  If new members do not respond to the inquiry statement, then the request will be deleted and the new member applicant will have to resubmit an invitation request. Personally identifiable information is not required for the Google account, and personal names do not need to be associated with the account used during group participation.  Information used for registration is used solely for controlling access to the group and to provide a means to restrict participation for those who violate the Group Policies.

## Membership Information

The Membership list is only accessible to Discussion Group Managers. This precaution helps reduce access to member contact information by potential malicious users. At the same time, all individual messages to the group contain contact information in the email address associated with the registered Google Account.  This information is made public through the message meta-data.

## Management Information

Employees at the National Institute of Standards and Technology and the VTT Technical Research Centre of Finland currently are assigned as Owners and Managers of the Discussion Group.  The role of Owners and Managers are defined on the GoogleGroups Help FAQ as:
"The original owner is the person who created the group, invited the first members, and chose the group's posting and access settings. Once the owner selects a member to be a manager, both the owner and the manager can approve posts, invite new members, create managers, and change the group's management settings. Only the owner, however, can create a co-owner, transfer ownership to another user, or remove the group."

## Discussion Group Posts

Posts from registered members are unmoderated and published directly to the public forum. Posts are immediately emailed to all members who elect the email delivery option.  However, all posts are reviewed by FDS-SMV Group Managers and any post that violates the policies herein may be taken down without notice.  Participants must also comply with applicable policies, regulations, and laws of their own locality. Posts are expected to show respect and consideration to others. The Group Owners and Managers will delete posts which obviously infringe upon copyrights or which are clearly off-topic or not relevant to technical discussions such as Spam, personal attacks, political statements, religious statements, cursing or other foul language, pornographic information or statements based on race, age, creed, color, sex, handicap, or sexual orientation.  Information provided by a NIST employee is subject to applicable laws and policies.

Discussion Group members are encouraged to read this article on [Effective Posting](https://github.com/firemodels/fds/wiki/Effective-Posting).
