" Vim syntax file generated by fds_make_syn.pl
" Language:     fds v. 4,5,6 input files
" Maintainer:   Andrew Louie <andrew.louie@wsp.com>
" Last change:  Jun 29, 2018
" Updated(2018-06-29):
" Will find all source files with NAMELIST keywords
" Updated(2016-08-12):
" Now pulls from Git instead of SVN
" Updated(2012-08-21):
" Now Reads hvac.f90 to highlight hvac keywords
" -------------------------------------------------
" TO USE:                                          
" copy fds.vim to $HOME/vimfiles/syntax
" add the following line to the $HOME/vimfiles/filetype.vim
" augroup filetypedetect
" au BufNewFile,BufRead *.fds setf fds
" augroup END
" -------------------------------------------------
" fds4 reads files that end in *.data
" fds5 reads files of any ext, but normally used .fds or .fds5
" For version 5.x: Clear all syntax items
" For version 7.x: Quit when a syntax file was already loaded
if version < 700
syntax clear
elseif exists("b:current_syntax")
  finish
endif

syn case match

"set unusal keywords
setlocal iskeyword+=_

" keywords NAMELIST Parameters
"
" Obselete NAMELIST-Keywords from FDS4
syn keyword FDS4OBS HEAT PIPE PL3D SMOD SPRK THCP GRID PDIM

" BNDE (read.f90)
syn keyword NAMELIST BNDE
syn keyword FDS5PA SPEC_ID QUANTITY PROP_ID PART_ID FYI CELL_CENTERED
" BNDF (read.f90)
syn keyword NAMELIST BNDF
syn keyword FDS5PA STATISTICS SPEC_ID QUANTITY PROP_ID PART_ID FYI CELL_CENTERED
" CLIP (read.f90)
syn keyword NAMELIST CLIP
syn keyword FDS5PA MINIMUM_TEMPERATURE MINIMUM_DENSITY MAXIMUM_TEMPERATURE MAXIMUM_DENSITY FYI
" COMB (read.f90)
syn keyword NAMELIST COMB
syn keyword FDS5PA TEMP_MAX_SMV TAU_FLAME TAU_CHEM SUPPRESSION RICHARDSON_ERROR_TOLERANCE RADIATIVE_FRACTION ODE_SOLVER 
syn keyword FDS5PA N_SIMPLE_CHEMISTRY_REACTIONS N_FIXED_CHEMISTRY_SUBSTEPS MAX_CHEMISTRY_SUBSTEPS INITIAL_UNMIXED_FRACTION  HRRPUV_MAX_SMV HRRPUV_CUT_MAX FUEL_H_TO_H2_FRACTION
syn keyword FDS5PA FUEL_C_TO_CO_FRACTION  FIXED_MIX_TIME EXTINCTION_MODEL CHECK_REALIZABILITY
" CORR (evac.f90)
syn keyword NAMELIST CORR
syn keyword FDS5PA  TRAVEL_TIME  ELEVATOR  COLOR  RGB  XB2 XB1   FAC_SPEED
syn keyword FDS5PA  MAX_HUMANS_INSIDE  EFF_LENGTH EFF_WIDTH   WIDTH2  WIDTH1  WIDTH  FYI
syn keyword FDS5PA  TO_NODE MAX_FLOW   CHECK_FLOW  FLOW_FIELD_ID  IOR  XB ID
" CSVF (read.f90)
syn keyword NAMELIST CSVF
syn keyword FDS5PA UVWFILE CSVFILE
" CTRL (read.f90)
syn keyword NAMELIST CTRL
syn keyword FDS5PA TRIP_DIRECTION TARGET_VALUE SETPOINT  RAMP_ID PROPORTIONAL_GAIN ON_BOUND N
syn keyword FDS5PA LATCH INPUT_ID  INTEGRAL_GAIN INITIAL_STATE ID FUNCTION_TYPE EVACUATION
syn keyword FDS5PA DIFFERENTIAL_GAIN DELAY CYCLE_TIME CYCLES  CONSTANT
" DEVC (read.f90)
syn keyword NAMELIST DEVC
syn keyword FDS5PA XYZ_UNITS Z_ID Y_ID X_ID XYZ XB VELO_INDEX UNITS
syn keyword FDS5PA TRIP_DIRECTION TIME_HISTORY TIME_AVERAGED  SURF_ID STATISTICS_START STATISTICS SPEC_ID
syn keyword FDS5PA SMOOTHING_FACTOR SETPOINT ROTATION R_ID RELATIVE REAC_ID  QUANTITY_RANGE
syn keyword FDS5PA QUANTITY2 QUANTITY PROP_ID  POINTS PIPE_INDEX PART_ID OUTPUT
syn keyword FDS5PA ORIENTATION_NUMBER ORIENTATION NO_UPDATE_CTRL_ID NO_UPDATE_DEVC_ID  NODE_ID MATL_ID LATCH
syn keyword FDS5PA IOR INIT_ID INITIAL_STATE ID HIDE_COORDINATES GHOST_CELL_IOR FYI FLOWRATE
syn keyword FDS5PA EVACUATION  DUCT_ID DRY DEVC_ID DEPTH DELAY CTRL_ID
syn keyword FDS5PA COORD_FACTOR CONVERSION_ADDEND CONVERSION_FACTOR BYPASS_FLOWRATE
" DOOR (evac.f90)
syn keyword NAMELIST DOOR
syn keyword FDS5PA  WAIT_AT_XYZ  TARGET_WHEN_CLOSED  LOCKED_WHEN_CLOSED  HEIGHT  SHOW  COLOR  RGB  EVAC_MESH
syn keyword FDS5PA  TIME_CLOSE TIME_OPEN   KEEP_XY  XYZ_SMOKE  COLOR_INDEX  MESH_ID EXIT_SIGN
syn keyword FDS5PA   KNOWN_DOOR  VENT_FFIELD  XYZ  WIDTH  FYI  TO_NODE MAX_FLOW
syn keyword FDS5PA   CHECK_FLOW  FLOW_FIELD_ID  IOR  XB ID
" DUMP (read.f90)
syn keyword NAMELIST DUMP
syn keyword FDS5PA GET_CUTCELLS_VERBOSE WRITE_XYZ VELOCITY_ERROR_FILE  UVW_TIMER T_DEVC_LINE_END SUPPRESS_DIAGNOSTICS STATUS_FILES
syn keyword FDS5PA SMOKE3D_SPEC_ID SMOKE3D_QUANTITY  SMOKE3D SIG_FIGS_EXP SIG_FIGS RENDER_FILE PLOT3D_VELO_INDEX
syn keyword FDS5PA PLOT3D_SPEC_ID PLOT3D_QUANTITY  PLOT3D_PART_ID NFRAMES MMS_TIMER MAXIMUM_PARTICLES MASS_FILE
syn keyword FDS5PA GEOM_DIAG FLUSH_FILE_BUFFERS  EB_PART_FILE DT_SLCF DT_SL3D DT_RESTART DT_PROF
syn keyword FDS5PA DT_PL3D DT_PART DT_MASS DT_ISOF DT_HRR DT_GEOM  DT_FLUSH
syn keyword FDS5PA DT_DEVC_LINE DT_DEVC DT_CTRL DT_CPU DT_BNDF DT_BNDE DEVC_COLUMN_LIMIT 
syn keyword FDS5PA CTRL_COLUMN_LIMIT COLUMN_DUMP_LIMIT CLIP_RESTART_FILES
" EDEV (evac.f90)
syn keyword NAMELIST EDEV
syn keyword FDS5PA  PROB  PRE_HIGH  PRE_LOW  PRE_PARA2  PRE_PARA  PRE_MEAN PRE_EVAC_DIST 
syn keyword FDS5PA  INPUT_ID  MESH_ID  PERS_ID  EVAC_ID  GLOBAL  TIME_DELAY  ID FYI
" ENTR (evac.f90)
syn keyword NAMELIST ENTR
syn keyword FDS5PA CROWBAR_INPUT_FILE   PROP_ID  AVATAR_TYPE  AGENT_TYPE  HEIGHT  SHOW  MAX_HUMANS_RAMP
syn keyword FDS5PA  MAX_HUMANS  AVATAR_RGB AVATAR_COLOR   COLOR  RGB  EVAC_MESH  COLOR_INDEX
syn keyword FDS5PA MESH_ID   KNOWN_DOOR_PROBS KNOWN_DOOR_NAMES   AFTER_REACTION_TIME TIME_STOP 
syn keyword FDS5PA  TIME_START  PERS_ID  QUANTITY  WIDTH FYI   MAX_FLOW  FLOW_FIELD_ID
syn keyword FDS5PA  IOR  XB ID
" EVAC (evac.f90)
syn keyword NAMELIST EVAC
syn keyword FDS5PA  CROWBAR_INPUT_FILE  TIME_START_FED  DELTA_Y  DELTA_X  TARGET_Y  TARGET_X GUARD_MEN_IN 
syn keyword FDS5PA  TIME_FALL_DOWN  PROP_ID  AVATAR_TYPE  AGENT_TYPE DET_HIGH DET_LOW DET_PARA2 DET_PARA
syn keyword FDS5PA DET_MEAN  PRE_HIGH PRE_LOW PRE_PARA2 PRE_PARA PRE_MEAN 
syn keyword FDS5PA  DET_EVAC_DIST  PRE_EVAC_DIST  SHOW  AVATAR_RGB AVATAR_COLOR   COLOR  RGB
syn keyword FDS5PA  EVAC_MESH COLOR_INDEX   MESH_ID  KNOWN_DOOR_PROBS KNOWN_DOOR_NAMES   GN_MAX
syn keyword FDS5PA  GN_MIN AFTER_REACTION_TIME   ANGLE  WIDTH  MAX_FLOW  IOR  TIME_STOP
syn keyword FDS5PA TIME_START   PERS_ID  FLOW_FIELD_ID  XB  DTSAM ID 
syn keyword FDS5PA  FYI  QUANTITY NUMBER_INITIAL_PERSONS
" EVHO (evac.f90)
syn keyword NAMELIST EVHO
syn keyword FDS5PA  TIME_FALL_DOWN  SHOW  COLOR  RGB  EVAC_MESH  MESH_ID  PERS_ID  EVAC_ID
syn keyword FDS5PA  XB  ID FYI
" EVSS (evac.f90)
syn keyword NAMELIST EVSS
syn keyword FDS5PA  COUNT_ONLY  VENT_FFIELD  SHOW  USE_V0  VBAR0 UBAR0   COLOR
syn keyword FDS5PA  RGB  EVAC_MESH  ESC_SPEED  FAC_V0_HORI  FAC_V0_DOWN FAC_V0_UP   IOR
syn keyword FDS5PA  HEIGHT0  HEIGHT  MESH_ID  XB  ID FYI
" EXIT (evac.f90)
syn keyword NAMELIST EXIT
syn keyword FDS5PA  WAIT_AT_XYZ  TARGET_WHEN_CLOSED  LOCKED_WHEN_CLOSED  HEIGHT  SHOW  COLOR  RGB  EVAC_MESH
syn keyword FDS5PA  TIME_CLOSE TIME_OPEN   KNOWN_DOOR  PERS_ID  EVAC_ID  XYZ_SMOKE  COLOR_INDEX
syn keyword FDS5PA MESH_ID   COUNT_DENSITY  VENT_FFIELD  XYZ  WIDTH  COUNT_ONLY  FYI
syn keyword FDS5PA MAX_FLOW   CHECK_FLOW  FLOW_FIELD_ID  IOR  XB ID
" GEOM (geom.f90)
syn keyword NAMELIST GEOM
syn keyword FDS5PA  GEOC_FILENAME BNDC_FILENAME   ZVALS  ZMIN  XYZ_DOT  XYZ  XYZ0
syn keyword FDS5PA  XB  VOLUS VERTS   TEXTURE_SCALE  TEXTURE_ORIGIN TEXTURE_MAPPING 
syn keyword FDS5PA  SURF_ID  SPHERE_TYPE  SPHERE_RADIUS SPHERE_ORIGIN   SCALE_DOT  SCALE  N_LONG
syn keyword FDS5PA  N_LEVELS  N_LAT MATL_ID   IJK  ID  GROTATE_DOT  GROTATE
syn keyword FDS5PA  GEOM_IDS  GAXIS  FACES  ELEV_DOT ELEV   DXYZ  DXYZ0
syn keyword FDS5PA  DT_GEOC  DT_BNDC  DSCALE  DELEV  DAZIM  CUTCELLS  COMPONENT_ONLY  AZIM_DOT
syn keyword FDS5PA  AZIM AUTO_TEXTURE
" HEAD (read.f90)
syn keyword NAMELIST HEAD
syn keyword FDS5PA TITLE FYI CHID
" HOLE (read.f90)
syn keyword NAMELIST HOLE
syn keyword FDS5PA XB TRANSPARENCY RGB MULT_ID MESH_ID ID FYI EVACUATION
syn keyword FDS5PA DEVC_ID CTRL_ID COLOR BLOCK_WIND
" HVAC (hvac.f90)
syn keyword NAMELIST HVAC
syn keyword FDS5PA XYZ VOLUME_FLOW VENT2_ID VENT_ID TYPE_ID TAU_VF TAU_FAN TAU_AC
syn keyword FDS5PA SURF_ID SPEC_ID ROUGHNESS REVERSE RAMP_LOSS RAMP_ID  PERIMETER
syn keyword FDS5PA NODE_ID N_CELLS MAX_PRESSURE MAX_FLOW MASS_FLOW  LOSS LOADING_MULTIPLIER
syn keyword FDS5PA LOADING LENGTH LEAK_ENTHALPY ID FIXED_Q FILTER_ID FAN_ID EFFICIENCY
syn keyword FDS5PA  DUCT_INTERP_TYPE DUCT_ID DIAMETER DEVC_ID DAMPER  CTRL_ID
syn keyword FDS5PA COOLANT_TEMPERATURE COOLANT_MASS_FLOW COOLANT_SPECIFIC_HEAT CLEAN_LOSS AREA AMBIENT AIRCOIL_ID
" INIT (read.f90)
syn keyword NAMELIST INIT
syn keyword FDS5PA NUMBER_INITIAL_PARTICLES  XYZ XB VOLUME_FRACTION UVW TEMPERATURE SPEC_ID
syn keyword FDS5PA SHAPE RADIUS  PARTICLE_WEIGHT_FACTOR PART_ID N_PARTICLES_PER_CELL N_PARTICLES MULT_ID
syn keyword FDS5PA MASS_PER_VOLUME MASS_PER_TIME  MASS_FRACTION ID HRRPUV HEIGHT 
syn keyword FDS5PA DZ DY DX DT_INSERT DIAMETER DEVC_ID DENSITY CTRL_ID
syn keyword FDS5PA CELL_CENTERED AUTO_IGNITION_TEMPERATURE
" ISOF (read.f90)
syn keyword NAMELIST ISOF
syn keyword FDS5PA VELO_INDEX VALUE SPEC_ID QUANTITY FYI
" MATL (read.f90)
syn keyword NAMELIST MATL
syn keyword FDS5PA VEGETATION THRESHOLD_TEMPERATURE THRESHOLD_SIGN SPEC_ID SPECIFIC_HEAT_RAMP SPECIFIC_HEAT  RGB
syn keyword FDS5PA REFRACTIVE_INDEX REFERENCE_TEMPERATURE REFERENCE_RATE PYROLYSIS_RANGE POROSITY PCR NU_O2 N_O2
syn keyword FDS5PA N_T N_S  N_REACTIONS NU_SPEC NU_MATL MATL_ID ID
syn keyword FDS5PA HEAT_OF_REACTION HEAT_OF_COMBUSTION HEATING_RATE GAS_DIFFUSION_DEPTH  FYI EMISSIVITY E
syn keyword FDS5PA DIFFUSIVITY_SPEC DENSITY CONDUCTIVITY_RAMP  CONDUCTIVITY COLOR BOILING_TEMPERATURE BETA_CHAR
syn keyword FDS5PA ALLOW_SWELLING ALLOW_SHRINKING ABSORPTION_COEFFICIENT A
" MESH (read.f90)
syn keyword NAMELIST MESH
syn keyword FDS5PA N_THREADS XB RGB  MULT_ID MPI_PROCESS LEVEL IJK
syn keyword FDS5PA ID  FYI EVAC_Z_OFFSET EVAC_HUMANS EVACUATION CYLINDRICAL COLOR
" MISC (read.f90)
syn keyword NAMELIST MISC
syn keyword FDS5PA WIND_ONLY  Y_O2_INFTY Y_CO2_INFTY VN_MIN VN_MAX VISIBILITY_FACTOR VERBOSE
syn keyword FDS5PA VEG_LEVEL_SET_UNCOUPLED VEG_LEVEL_SET_COUPLED  UVW_FILE TURB_INIT_CLOCK TURBULENT_DEPOSITION TURBULENCE_MODEL TMPA
syn keyword FDS5PA  THICKEN_OBSTRUCTIONS THERMOPHORETIC_SETTLING THERMOPHORETIC_DEPOSITION  TEXTURE_ORIGIN TEST_FILTER_QUADRATURE TERRAIN_IMAGE
syn keyword FDS5PA TERRAIN_CASE TENSOR_DIFFUSIVITY  TAU_DEFAULT SURF_DEFAULT SUPPRESSION STRATIFICATION 
syn keyword FDS5PA SOOT_OXIDATION SOLID_PHASE_ONLY SMOKE_ALBEDO SLIP_CONDITION SIMULATION_MODE SHARED_FILE_SYSTEM SC 
syn keyword FDS5PA RESTART_CHID RESTART RESEARCH_MODE RADIATION  RAMP_GZ RAMP_GY RAMP_GX
syn keyword FDS5PA PROCESS_ALL_MESHES P_INF PROJECTION PROCESS_CUTCELLS PR  POROUS_FLOOR PROFILING
syn keyword FDS5PA PERIODIC_TEST PARTICLE_CFL PARTICLE_CFL_MIN PARTICLE_CFL_MAX OVERWRITE  NO_EVACUATION NOISE_VELOCITY
syn keyword FDS5PA NOISE  NEAR_WALL_TURBULENCE_MODEL N_INITIAL_PARTICLE_SUBSTEPS  MPI_TIMEOUT MAXIMUM_VISIBILITY MAX_LEAK_PATHS
syn keyword FDS5PA  IMMERSED_BOUNDARY_METHOD IBLANK_SMV  HVAC_MASS_TRANSPORT HVAC_LOCAL_PRESSURE HUMIDITY 
syn keyword FDS5PA H_F_REFERENCE_TEMPERATURE GVEC GRAVITATIONAL_SETTLING  GRAVITATIONAL_DEPOSITION GAMMA FYI FREEZE_VELOCITY
syn keyword FDS5PA FLUX_LIMITER POSITIVE_ERROR_TEST  HT3D_TEST HVAC_PRES_RELAX EXTERNAL_BOUNDARY_CORRECTION  EVAC_TIME_ITERATIONS
syn keyword FDS5PA EVAC_SURF_DEFAULT EVAC_PRESSURE_ITERATIONS EVACUATION_MC_MODE EVACUATION_DRILL  ENTHALPY_TRANSPORT DEPOSITION DRAG_CFL_MAX
syn keyword FDS5PA DO_IMPLICIT_CCREGION DNS C_WALE  C_VREMAN C_SMAGORINSKY C_RNG_CUTOFF C_RNG
syn keyword FDS5PA C_DEARDORFF CORRECT_SUBGRID_TEMPERATURE  CONSTANT_SPECIFIC_HEAT_RATIO CONSTANT_H_SOLID  COMPUTE_CUTCELLS_ONLY CHECK_VN
syn keyword FDS5PA CHECK_HT  CFL_VELOCITY_NORM CFL_MIN CFL_MAX CNF_CUTOFF  CHECK_MASS_CONSERVE
syn keyword FDS5PA CC_ZEROIBM_VELO CCVOL_LINK CC_IBM BNDF_DEFAULT BAROCLINIC  ASSUMED_GAS_TEMPERATURE_RAMP 
syn keyword FDS5PA ASSUMED_GAS_TEMPERATURE ALLOW_UNDERSIDE_PARTICLES ALLOW_SURFACE_PARTICLES AEROSOL_AL2O3 AGGLOMERATION
" MULT (read.f90)
syn keyword NAMELIST MULT
syn keyword FDS5PA N_UPPER N_UPPER_SKIP N_LOWER_SKIP N_LOWER  K_UPPER_SKIP K_UPPER K_LOWER_SKIP
syn keyword FDS5PA K_LOWER  J_UPPER_SKIP J_UPPER J_LOWER_SKIP J_LOWER  I_UPPER_SKIP
syn keyword FDS5PA I_UPPER I_LOWER_SKIP I_LOWER  ID FYI DZ0 DZ
syn keyword FDS5PA DY0 DY DX0 DXB DX
" OBST (read.f90)
syn keyword NAMELIST OBST
syn keyword FDS5PA XYZ XB WIDTH TRANSPARENCY  THICKEN THETA TEXTURE_ORIGIN
syn keyword FDS5PA SURF_IDS SURF_ID6 SURF_ID SHAPE  RGB REMOVABLE RADIUS
syn keyword FDS5PA  PYRO3D_MASS_TRANSPORT PYRO3D_IOR PROP_ID PERMIT_HOLE OVERLAY OUTLINE ORIENTATION
syn keyword FDS5PA  NOTERRAIN MULT_ID MESH_ID MATL_ID LENGTH  INTERNAL_HEAT_SOURCE
syn keyword FDS5PA ID HT3D HEIGHT FYI EVACUATION DEVC_ID CTRL_ID COLOR
syn keyword FDS5PA  BULK_DENSITY BNDF_OBST BNDF_FACE ALLOW_VENT
" PART (read.f90)
syn keyword NAMELIST PART
syn keyword FDS5PA VERTICAL_VELOCITY TURBULENT_DISPERSION TARGET_ONLY SURF_ID SURFACE_TENSION  STATIC SPEC_ID
syn keyword FDS5PA SIGMA_D SHAPE_FACTOR SECOND_ORDER_PARTICLE_TRANSPORT SAMPLING_FACTOR  RUNNING_AVERAGE_FACTOR RGB REAL_REFRACTIVE_INDEX
syn keyword FDS5PA RADIATIVE_PROPERTY_TABLE QUANTITIES_SPEC_ID  QUANTITIES PROP_ID POROUS_VOLUME_FRACTION PERIODIC_Z PERIODIC_Y
syn keyword FDS5PA PERIODIC_X PERMEABILITY ORIENTATION N_STRATA  MONODISPERSE MINIMUM_DIAMETER MAXIMUM_DIAMETER
syn keyword FDS5PA MASSLESS INITIAL_TEMPERATURE ID HORIZONTAL_VELOCITY  HEAT_OF_COMBUSTION GAMMA_D FYI
syn keyword FDS5PA FREE_AREA_FRACTION  EMBER_VELOCITY_THRESHOLD EMBER_PARTICLE EMBER_DENSITY_THRESHOLD  DRAG_LAW DRAG_COEFFICIENT
syn keyword FDS5PA DISTRIBUTION DIAMETER DEVC_ID  DENSE_VOLUME_FRACTION CTRL_ID  COMPLEX_REFRACTIVE_INDEX
syn keyword FDS5PA COLOR CNF_RAMP_ID CHECK_DISTRIBUTION BREAKUP_SIGMA_D  BREAKUP_RATIO BREAKUP_GAMMA_D BREAKUP_DISTRIBUTION
syn keyword FDS5PA BREAKUP_CNF_RAMP_ID BREAKUP AGE
" PERS (evac.f90)
syn keyword NAMELIST PERS
syn keyword FDS5PA  DISCARD_SMOKE_INFO  MASS_OF_AGENT CROWBAR_DT_READ   FED_ACTIVITY  SMOKE_KS_SPEED_FUNCTION  SMOKE_SPEED_BETA SMOKE_SPEED_ALPHA
syn keyword FDS5PA   TIME_INIT_NERVOUSNESS  MAX_INITIAL_OVERLAP MAXIMUM_V0_FACTOR   T_ASET_TFAC_HAWK  T_0_HAWK T_ASET_HAWK
syn keyword FDS5PA   PROB_FALL_DOWN  A_FAC_FALLEN  TAU_FALL_DOWN  D_OVERLAP_FALL  F_MAX_FALL F_MIN_FALL 
syn keyword FDS5PA  A_HAWK_T_START  T_STOP_HD_GAME  THETA_HAWK  EPSILON_HAWK  DELTA_HAWK ALPHA_HAWK   HERDING_TAU_FACTOR
syn keyword FDS5PA  A_HAWK_T_FACTOR  R_HAWK_DOVE  C_HAWK MAX_HUMANS_DIM   EVAC_DELTA_SEE  EVAC_FDS6  DOT_HERDING
syn keyword FDS5PA  I_HERDING_TYPE  WR_HERDING  W0_HERDING R_HERDING   FAC_DOOR_OLD2  FAC_DOOR_OLD  FAC_V0_HORI
syn keyword FDS5PA  FAC_V0_DOWN FAC_V0_UP   NASH_CLOSE_ENOUGH  CF_MIN_B  FAC_DOOR_WAIT  FAC_DOOR_ALPHA FAC_DOOR_QUEUE
syn keyword FDS5PA   CF_FAC_TAUS  CF_MIN_TAU_INER  CF_MIN_TAU  CF_FAC_A_WALL CF_MIN_A   FAC_NOCF
syn keyword FDS5PA  FAC_V0_NOCF  FAC_V0_DIR  FAC_2_WALL FAC_1_WALL   FAC_CF  CONST_CF  FAC_DF
syn keyword FDS5PA  CONST_DF  THETA_SECTOR TAU_CHANGE_V0   HUMAN_SMOKE_HEIGHT  AVATAR_RGB  AVATAR_COLOR  COLOR
syn keyword FDS5PA  RGB TAU_CHANGE_DOOR   SMOKE_MIN_SPEED_VISIBILITY  SMOKE_MIN_SPEED_FACTOR SMOKE_MIN_SPEED   DEAD_COLOR
syn keyword FDS5PA  DEAD_RGB  COLOR_INDEX  OUTPUT_NERVOUSNESS OUTPUT_ACCELERATION   OUTPUT_TOTAL_FORCE  OUTPUT_CONTACT_FORCE  OUTPUT_ANGLE
syn keyword FDS5PA OUTPUT_MOTIVE_ANGLE   OUTPUT_DENSITY  OUTPUT_OMEGA  OUTPUT_FED  OUTPUT_MOTIVE_FORCE OUTPUT_SPEED 
syn keyword FDS5PA  V_ANGULAR  V_ANGULAR_MAX  V_MAX FC_DAMPING   M_INERTIA  TAU_ROT  D_SHOULDER_MEAN
syn keyword FDS5PA D_TORSO_MEAN   EVAC_DT_MIN  EVAC_DT_MAX  DENS_INIT TDET_SMOKE_DENS   COLOR_METHOD
syn keyword FDS5PA  FED_DOOR_CRIT NOT_RANDOM   DEFAULT_PROPERTIES RADIUS_COMPLETE_1   RADIUS_COMPLETE_0  GROUP_EFF
syn keyword FDS5PA I_FRIC_SW   NOISECM  NOISETH  NOISEME  LAMBDA_WALL  FAC_B_WALL FAC_A_WALL
syn keyword FDS5PA   GROUP_DENS KAPPA GAMMA  C_YOUNG L_NON_SP FCONST_B FCONST_A
syn keyword FDS5PA  TAU_HIGH TAU_LOW TAU_PARA2 TAU_PARA TAU_MEAN  DET_HIGH
syn keyword FDS5PA DET_LOW DET_PARA2 DET_PARA DET_MEAN  PRE_HIGH PRE_LOW PRE_PARA2
syn keyword FDS5PA PRE_PARA PRE_MEAN  DIA_HIGH DIA_LOW DIA_PARA2 DIA_PARA DIA_MEAN
syn keyword FDS5PA  VEL_HIGH VEL_LOW VEL_PARA2 VEL_PARA VEL_MEAN  TAU_EVAC_DIST
syn keyword FDS5PA DET_EVAC_DIST PRE_EVAC_DIST  VELOCITY_DIST DIAMETER_DIST ID FYI
" PRES (read.f90)
syn keyword NAMELIST PRES
syn keyword FDS5PA VELOCITY_TOLERANCE SUSPEND_PRESSURE_ITERATIONS SOLVER  RELAXATION_FACTOR PRESSURE_TOLERANCE PRESSURE_RELAX_TIME MAX_PRESSURE_ITERATIONS
syn keyword FDS5PA   SCARC_COARSE_LEVEL  SCARC_COARSE_OMEGA  SCARC_COARSE_ACCURACY  SCARC_COARSE_ITERATIONS SCARC_COARSE   SCARC_PRECISION
syn keyword FDS5PA  SCARC_PRECON_OMEGA  SCARC_PRECON_ACCURACY  SCARC_PRECON_ITERATIONS SCARC_PRECON   SCARC_SMOOTH_OMEGA  SCARC_SMOOTH_ACCURACY  SCARC_SMOOTH_ITERATIONS
syn keyword FDS5PA SCARC_SMOOTH   SCARC_MULTIGRID_INTERPOL  SCARC_MULTIGRID_COARSENING  SCARC_MULTIGRID_LEVEL SCARC_MULTIGRID_CYCLE   SCARC_TWOLEVEL
syn keyword FDS5PA  SCARC_PRECISION  SCARC_MULTIGRID_ACCURACY  SCARC_MULTIGRID_ITERATIONS SCARC_MULTIGRID   SCARC_KRYLOV_INTERPOL  SCARC_KRYLOV_ACCURACY  SCARC_KRYLOV_ITERATIONS
syn keyword FDS5PA SCARC_KRYLOV   SCARC_ACCURACY  SCARC_CSV  SCARC_DEBUG  SCARC_VERBOSE  SCARC_DISCRETIZATION SCARC_METHOD
syn keyword FDS5PA  LAPLACE_PRESSURE_CORRECTION ITERATION_SUSPEND_FACTOR FISHPAK_BC CHECK_POISSON
" PROF (read.f90)
syn keyword NAMELIST PROF
syn keyword FDS5PA XYZ QUANTITY IOR INIT_ID ID FYI FORMAT_INDEX
" PROP (read.f90)
syn keyword NAMELIST PROP
syn keyword FDS5PA BEAD_SPECIFIC_HEAT BEAD_DIAMETER BEAD_DENSITY  DROPLET_VELOCITY BEAD_HEAT_TRANSFER_COEFFICIENT BEAD_EMISSIVITY 
syn keyword FDS5PA VELOCITY_COMPONENT SPRAY_PATTERN_TABLE SPRAY_PATTERN_SHAPE SPRAY_PATTERN_MU SPRAY_PATTERN_BETA  SPRAY_ANGLE SPECIFIC_HEAT
syn keyword FDS5PA SPEC_ID SMOKEVIEW_PARAMETERS SMOKEVIEW_ID RTI QUANTITY PXX PX PRESSURE_RAMP
syn keyword FDS5PA PDPA_START  PDPA_RADIUS PDPA_NORMALIZE PDPA_N PDPA_M PDPA_INTEGRATE PDPA_HISTOGRAM_CUMULATIVE
syn keyword FDS5PA  PDPA_HISTOGRAM_NBINS  PDPA_HISTOGRAM_LIMITS PDPA_HISTOGRAM PDPA_END PART_ID PARTICLE_VELOCITY 
syn keyword FDS5PA PARTICLES_PER_SECOND  P0 ORIFICE_DIAMETER OPERATING_PRESSURE OFFSET MASS_FLOW_RATE LENGTH
syn keyword FDS5PA K_FACTOR INITIAL_TEMPERATURE  ID HEAT_TRANSFER_COEFFICIENT GAUGE_TEMPERATURE GAUGE_EMISSIVITY 
syn keyword FDS5PA FLOW_TAU FLOW_RATE FLOW_RAMP EMISSIVITY DIAMETER DENSITY C_FACTOR CHARACTERISTIC_VELOCITY
syn keyword FDS5PA  FED_ACTIVITY BETA_E BETA_C ALPHA_E ALPHA_C ACTIVATION_TEMPERATURE ACTIVATION_OBSCURATION
" RADI (read.f90)
syn keyword NAMELIST RADI
syn keyword FDS5PA NUMBER_INITIAL_ITERATIONS  MIE_NDG MIE_MAXIMUM_DIAMETER MIE_MINIMUM_DIAMETER WIDE_BAND_MODEL  TIME_STEP_INCREMENT
syn keyword FDS5PA RTE_SOURCE_CORRECTION RADTMP RADIATION_ITERATIONS RADIATION QR_CLIP PATH_LENGTH  NUMBER_RADIATION_ANGLES
syn keyword FDS5PA NMIEANG KAPPA0 INITIAL_RADIATION_ITERATIONS C_MIN C_MAX BAND_LIMITS ANGLE_INCREMENT
" RAMP (read.f90)
syn keyword NAMELIST RAMP
syn keyword FDS5PA Z X T NUMBER_INTERPOLATION_POINTS ID FYI F DEVC_ID
syn keyword FDS5PA CTRL_ID
" REAC (read.f90)
syn keyword NAMELIST REAC
syn keyword FDS5PA THIRD_BODY SPEC_ID_NU SPEC_ID_N_S  SOOT_YIELD SOOT_H_FRACTION REVERSE REAC_MASS_ERROR
syn keyword FDS5PA  REAC_ATOM_ERROR RAMP_CHI_R RADIATIVE_FRACTION PRIORITY O N_T N_S
syn keyword FDS5PA NU N LOWER_OXYGEN_LIMIT IDEAL ID  HEAT_OF_COMBUSTION H
syn keyword FDS5PA FYI FWD_ID FUEL_RADCAL_ID  FUEL FORMULA EQUATION K
syn keyword FDS5PA EPUMO2 E  CRITICAL_FLAME_TEMPERATURE CO_YIELD CHECK_ATOM_BALANCE C AUTO_IGNITION_TEMPERATURE
syn keyword FDS5PA A
" SLCF (read.f90)
syn keyword NAMELIST SLCF
syn keyword FDS5PA XB VELO_INDEX VECTOR  SPEC_ID SMV_OFFSET SLICETYPE REAC_ID
syn keyword FDS5PA QUANTITY2 QUANTITY PROP_ID PBZ PBY PBX PART_ID MINIMUM_VALUE
syn keyword FDS5PA MESH_NUMBER  MATL_ID MAXIMUM_VALUE LEVEL_SET_FIRE_LINE IOR ID FYI
syn keyword FDS5PA FIRE_LINE FACE_CENTERED EVACUATION CELL_CENTERED AGL_SLICE
" SPEC (read.f90)
syn keyword NAMELIST SPEC
syn keyword FDS5PA VOLUME_FRACTION VISCOSITY_LIQUID VISCOSITY VAPORIZATION_TEMPERATURE SPECIFIC_HEAT_LIQUID SPECIFIC_HEAT  SPEC_ID
syn keyword FDS5PA SIGMALJ REFERENCE_TEMPERATURE REFERENCE_ENTHALPY RAMP_MU RAMP_K RAMP_G_F RAMP_D RAMP_CP_L
syn keyword FDS5PA RAMP_CP  RADCAL_ID PRIMITIVE PR_GAS N_BINS MW MIN_DIAMETER
syn keyword FDS5PA  MELTING_TEMPERATURE MEAN_DIAMETER MAX_DIAMETER MASS_FRACTION_0 MASS_FRACTION MASS_EXTINCTION_COEFFICIENT 
syn keyword FDS5PA LUMPED_COMPONENT_ONLY ID H_V_REFERENCE_TEMPERATURE HEAT_OF_VAPORIZATION FYI FORMULA  FLD_LETHAL_DOSE
syn keyword FDS5PA FIC_CONCENTRATION EPSILONKLJ ENTHALPY_OF_FORMATION DIFFUSIVITY DENSITY_SOLID DENSITY_LIQUID  COPY_LUMPED
syn keyword FDS5PA CONDUCTIVITY_SOLID CONDUCTIVITY_LIQUID CONDUCTIVITY BETA_LIQUID BACKGROUND AEROSOL
" STRS (evac.f90)
syn keyword NAMELIST STRS
syn keyword FDS5PA  EVAC_Z_OFFSET  IJK  COLOR  RGB  FAC_V0_HORI  FAC_V0_DOWN FAC_V0_UP 
syn keyword FDS5PA  VERTICAL_LANDING_SEPARATION  XB_LANDINGS N_LANDINGS   MESH_ID  LEFT_HANDED  RIGHT_HANDED  TO_NODE
syn keyword FDS5PA  XB_CORES  XB_CORE  XB ID
" SURF (read.f90)
syn keyword NAMELIST SURF
syn keyword FDS5PA VOLUME_FLUX TAU_EXTERNAL_FLUX EXTERNAL_FLUX_RAMP  ZETA_FRONT Z0 XYZ WIDTH
syn keyword FDS5PA VOLUME_FLOW VEL_T VEL_GRAD VEL_BULK VEL  VEG_LSET_ELLIPSE_HEAD VEG_LSET_TAN2
syn keyword FDS5PA VEG_LSET_ELLIPSE VEG_LSET_BETA VEG_LSET_HT VEG_LSET_SIGMA  VEG_LSET_WIND_EXP VEG_LSET_ROS_HEAD VEG_LSET_ROS_FLANK
syn keyword FDS5PA VEG_LSET_ROS_BACK  VEG_LEVEL_SET_SPREAD VEGETATION_SVRATIO VEGETATION_NO_BURN VEGETATION_MOISTURE VEG_LSET_QCON 
syn keyword FDS5PA VEGETATION_LSET_IGNITE_TIME VEGETATION_LOAD VEGETATION_LINEAR_DEGRAD VEGETATION_LAYERS VEGETATION_INITIAL_TEMP  VEGETATION_HEIGHT VEGETATION_GROUND_TEMP
syn keyword FDS5PA VEGETATION_ELEMENT_DENSITY VEGETATION_CHAR_FRACTION  VEGETATION_CDRAG VEGETATION_ARRHENIUS_DEGRAD VEGETATION TRANSPARENCY TMP_INNER
syn keyword FDS5PA TMP_FRONT TMP_BACK  THICKNESS TGA_HEATING_RATE TGA_FINAL_TEMPERATURE TGA_ANALYSIS 
syn keyword FDS5PA TEXTURE_WIDTH TEXTURE_MAP TEXTURE_HEIGHT TAU_V TAU_T TAU_Q TAU_PART TAU_MF
syn keyword FDS5PA TAU_EF  STRETCH_FACTOR SPREAD_RATE  SPEC_ID ROUGHNESS RGB
syn keyword FDS5PA RAMP_V_Z RAMP_V_Y RAMP_V_X RAMP_V RAMP_T_I RAMP_T RAMP_Q RAMP_PART
syn keyword FDS5PA  RAMP_MF RAMP_EF RADIUS PROFILE PLE PART_ID PARTICLE_SURFACE_DENSITY
syn keyword FDS5PA PARTICLE_MASS_FLUX NPPC NO_SLIP  NET_HEAT_FLUX N_LAYER_CELLS_MAX N_CELLS_MAX MLRPUA
syn keyword FDS5PA MINIMUM_LAYER_THICKNESS MATL_MASS_FRACTION  MATL_ID MASS_TRANSFER_COEFFICIENT MASS_FRACTION MASS_FLUX_VAR MASS_FLUX_TOTAL
syn keyword FDS5PA MASS_FLUX LENGTH LEAK_PATH  LAYER_DIVIDE INTERNAL_HEAT_SOURCE INNER_RADIUS IGNITION_TEMPERATURE
syn keyword FDS5PA ID HT3D HRRPUA HEAT_TRANSFER_MODEL  HEAT_TRANSFER_COEFFICIENT_BACK HEAT_TRANSFER_COEFFICIENT HEAT_OF_VAPORIZATION
syn keyword FDS5PA GEOMETRY FYI FREE_SLIP  FIRELINE_MLR_MAX  EXTINCTION_TEMPERATURE E_COEFFICIENT
syn keyword FDS5PA EXTERNAL_FLUX EVAC_DEFAULT EMISSIVITY_BACK EMISSIVITY DT_INSERT  DEFAULT CONVERT_VOLUME_TO_MASS
syn keyword FDS5PA CONVECTIVE_HEAT_FLUX CONVECTION_LENGTH_SCALE  COLOR C_VERTICAL C_HORIZONTAL  C_FORCED_RE_EXP
syn keyword FDS5PA C_FORCED_RE C_FORCED_PR_EXP C_FORCED_CONSTANT CELL_SIZE_FACTOR BURN_AWAY BACKING  AUTO_IGNITION_TEMPERATURE
syn keyword FDS5PA AREA_ADJUST ADIABATIC
" TABL (read.f90)
syn keyword NAMELIST TABL
syn keyword FDS5PA TABLE_DATA ID FYI
" TIME (read.f90)
syn keyword NAMELIST TIME
syn keyword FDS5PA TWFIN  WALL_INCREMENT_HT3D WALL_INCREMENT TIME_SHRINK_FACTOR T_END_GEOM T_END T_BEGIN
syn keyword FDS5PA  RESTRICT_TIME_STEP LOCK_TIME_STEP LIMITING_DT_RATIO FYI EVAC_DT_STEADY_STATE EVAC_DT_FLOWFIELD DT
" TRNX (read.f90)
syn keyword NAMELIST TRNX
syn keyword FDS5PA PC MESH_NUMBER IDERIV FYI CC
" TRNY (read.f90)
syn keyword NAMELIST TRNY
syn keyword FDS5PA PC MESH_NUMBER IDERIV FYI CC
" TRNZ (read.f90)
syn keyword NAMELIST TRNZ
syn keyword FDS5PA PC MESH_NUMBER IDERIV FYI CC
" VENT (read.f90)
syn keyword NAMELIST VENT
syn keyword FDS5PA XYZ XB WIND VEL_RMS UVW TRANSPARENCY TMP_EXTERIOR_RAMP 
syn keyword FDS5PA TMP_EXTERIOR TEXTURE_ORIGIN SURF_ID SPREAD_RATE RGB REYNOLDS_STRESS RADIUS PRESSURE_RAMP
syn keyword FDS5PA PBZ PBY PBX OUTLINE  OBST_ID N_EDDY MULT_ID
syn keyword FDS5PA MESH_ID MB L_EDDY_IJ L_EDDY IOR ID FYI EVACUATION
syn keyword FDS5PA DYNAMIC_PRESSURE DEVC_ID CTRL_ID COLOR
" WIND (read.f90)
syn keyword NAMELIST WIND
syn keyword FDS5PA Z_REF Z_0 W0 V0 USE_ATMOSPHERIC_INTERPOLATION U0 U_STAR TMP_REF
syn keyword FDS5PA THETA_STAR STRATIFICATION SPONGE_CELLS SPEED  REFERENCE_TEMPERATURE REFERENCE_HEIGHT RAMP_W0_Z
syn keyword FDS5PA RAMP_V0_Z RAMP_U0_Z RAMP_W0_T RAMP_V0_T RAMP_U0_T RAMP_TMP0_Z  RAMP_FVZ_T
syn keyword FDS5PA RAMP_FVY_T RAMP_FVX_T RAMP_SPEED RAMP_DIRECTION POTENTIAL_TEMPERATURE_CORRECTION  OBUKHOV_LENGTH MEAN_FORCING
syn keyword FDS5PA LAPSE_RATE  L GROUND_LEVEL FYI FORCE_VECTOR DT_MEAN_FORCING DIRECTION
syn keyword FDS5PA CORIOLIS_VECTOR
" ZONE (read.f90)
syn keyword NAMELIST ZONE
syn keyword FDS5PA PERIODIC XB LEAK_REFERENCE_PRESSURE LEAK_PRESSURE_EXPONENT LEAK_AREA ID
syn match hBool /\(\.TRUE\.\)\|\(\.FALSE\.\)/ contained

"Numbers of various sorts, Copied the Fortran syntax file

" Integers
syn match FDSInterger	display "\<\d\+\(_\a\w*\)\=\>"
" floating point number, without a decimal point
syn match FDSFloat	display	"\<\d\+[deq][-+]\=\d\+\(_\a\w*\)\=\>"
" floating point number, starting with a decimal point
syn match FDSNumber 	display "\<\.\d\+\([deq][-+]\=\d\+\)\=\(_\a\w*\)\=\>"
" floating point number, no digits after decimal
syn match FDSNumber	display "\<\d\+\.\([deq][-+]\=\d\+\)\=\(_\a\w*\)\=\>"
" floating point number, D or Q exponents
syn match FDSNumber	display	"\<\d\+\.\d\+\([dq][-+]\=\d\+\)\=\(_\a\w*\)\=\>"
" floating point number
syn match FDSNumber	display	"\<\d\+\.\d\+\(e[-+]\=\d\+\)\=\(_\a\w*\)\=\>"

syn match FDSOperator	"\(\(>\|<\)=\=\|==\|/=\|=\)"

" strings, enclosed in single or double quotes
syntax region hString start=/"\|'/ end=/"\|'/ contained

" instructions - Anything that begins with & and end with /
syn region instructions start=/^\s*&/ end=/[/]/ contains=FDS4OBS,hstring,FDS5PA,NAMELIST,FDSNumber,FDSFloat,FDSInterger,FDSOperator,hBool contained

" comments: everything is a comment, unless it is an instruction, see above
syn match  comment /.*/ contains=instructions

" syntax sync
syntax sync minlines=150
syn case match

" Define the default highlighting.
" For version 5.7 and earlier: only when not done already
" For version 5.8 and later: only when an item doesn't have highlighting yet
if version >= 508 || !exists("did_blank_syntax_inits")
  if version < 508
    let did_blank_syntax_inits = 1
    command -nargs=+ HiLink hi link <args>
  else
    command -nargs=+ HiLink hi def link <args>
  endif

  HiLink FDS4OBS		Error
  HiLink instructions		Statement
  HiLink FDSNumber 		Number
  HiLink FDSInterger		Number
  HiLink FDSFloat		Number
  HiLink hBool			Boolean
  HiLink comment		Comment
  HiLink hString		String
  HiLink FDS5PA			Identifier
  HiLink NAMELIST		PreProc
  HiLink FDSOperator	        Operator

  delcommand HiLink
endif
let b:current_syntax = "fds"
" vim: ts=8
